SystemOrganization addCategory: #'Neo4reSt-Core'!

Error subclass: #N4Error
	instanceVariableNames: 'properties response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4Error subclass: #N4CannotDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

!N4Error class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:02'!
properties: assocs
	^self new properties: assocs! !

!N4Error class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 22:22'!
response: response
	^self new response: response! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:01'!
properties
	"Answer the value of properties"

	^ properties! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:01'!
properties: anObject
	"Set the value of properties"

	properties := anObject! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:22'!
response
	"Answer the value of response"

	^ response! !

!N4Error methodsFor: 'accessing' stamp: 'mu 11/27/2011 22:22'!
response: anObject
	"Set the value of response"

	response := anObject! !

N4Error subclass: #N4NoContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4Error subclass: #N4NotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

Object subclass: #N4PortableUtil
	instanceVariableNames: ''
	classVariableNames: 'ActualClass'
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4PortableUtil class
	instanceVariableNames: 'default'!

N4PortableUtil class
	instanceVariableNames: 'default'!

!N4PortableUtil class methodsFor: 'private' stamp: 'mu 11/27/2011 12:39'!
activate
	ActualClass := self.
	^ActualClass! !

!N4PortableUtil class methodsFor: 'instance creation' stamp: 'mu 11/27/2011 16:18'!
default
	default ifNil: [default := ((N4PortableUtil subclasses at: 1) activate) new].
	^ default! !

!N4PortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 12:39'!
initDefault
	default := nil! !

!N4PortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 12:39'!
initialize
	"override"! !

!N4PortableUtil methodsFor: 'converting' stamp: 'mu 2/13/2012 00:51'!
asProperties: someProps

	^someProps isArray ifTrue: [someProps] ifFalse: [Array with: someProps].! !

!N4PortableUtil methodsFor: 'converting' stamp: 'mu 6/2/2012 21:54'!
convertToNative: value using: settings
	^value! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:41'!
deleteJsonFrom: urlString ! !

!N4PortableUtil methodsFor: 'converting' stamp: 'mu 4/22/2012 22:33'!
dictionaryFromAssociations: assocs
	| dict |
	dict := Dictionary new: assocs size.
	dict addAll: assocs.
	^ dict! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:42'!
getJsonFrom: urlString

	! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/29/2011 23:03'!
getJsonOrEmptyFrom: urlString

	^[self getJsonFrom: urlString]
		on: N4NoContent
		do: [:ex | ex return: #()]! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonDelete: urlString ! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/29/2011 22:59'!
httpJsonGet: urlString
! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonPost: urlString
	
	! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 22:41'!
httpJsonPost: urlString content: jsonString
	
	! !

!N4PortableUtil methodsFor: 'actions-http' stamp: 'MasashiUmezawa 7/5/2015 22:20'!
httpSetAuthenticationInfo! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 22:42'!
jsonStringFrom: assocs
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 12/9/2011 00:35'!
pickIdFrom: uriString 
	"N4SqPortableUtil default pickIdFrom: 'http://localhost:7474/db/data/node/10'"
	"N4SqPortableUtil default pickIdFrom: 'http://localhost:7474/db/'"
	| sz |
	(sz := uriString size)
		to: 1
		by: -1
		do: [:idx | $/ = (uriString at: idx)
				ifTrue: [| chopped |
					chopped := uriString copyFrom: idx + 1 to: sz.
					^ chopped isEmpty
						ifTrue: [0]
						ifFalse: [chopped asInteger]]].
	^ -1! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:40'!
postJson: json to: urlString

	! !

!N4PortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 22:41'!
postJsonTo: urlString
	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 22:42'!
readJsonFrom: aStream

	! !

!N4PortableUtil methodsFor: 'read/write' stamp: 'mu 12/23/2011 13:05'!
readJsonFromResponse: httpResponse! !

!N4PortableUtil methodsFor: 'releasing' stamp: 'mu 6/2/2012 21:45'!
release! !

!N4PortableUtil methodsFor: 'accessing' stamp: 'MasashiUmezawa 7/5/2015 22:22'!
settings
	^N4Settings default! !

!N4PortableUtil methodsFor: 'error handling' stamp: 'mu 11/27/2011 22:42'!
signalErrorBasedOn: response ! !

!N4PortableUtil methodsFor: 'misc utils' stamp: 'mu 11/27/2011 23:58'!
string: aString beginsWith: prefix 
	^ (prefix, '*') match: aString! !

!N4PortableUtil methodsFor: 'converting' stamp: 'MasashiUmezawa 1/20/2013 23:25'!
stringFrom: anObject
	^ anObject asString! !

!N4PortableUtil methodsFor: 'converting' stamp: 'MasashiUmezawa 1/20/2013 23:32'!
urlEncodedStringFrom: anObject
	"By default - just escape slash - mostly we can leave full url encoding to the underlying http client"
	| str |
	str := self stringFrom: anObject.
	^str copyReplaceAll: '/' with: '%2F'! !

Object subclass: #N4Settings
	instanceVariableNames: 'settingsDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

N4Settings class
	instanceVariableNames: 'default'!

N4Settings class
	instanceVariableNames: 'default'!

!N4Settings class methodsFor: 'instance creation' stamp: 'mu 6/2/2012 21:23'!
default
	default ifNil: [default := self new].
	^default! !

!N4Settings class methodsFor: 'class initialization' stamp: 'mu 6/2/2012 21:23'!
initialize
	default := nil! !

!N4Settings methodsFor: 'actions-dictionary' stamp: 'mu 6/2/2012 21:23'!
at: key
	^self settingsDict at: key! !

!N4Settings methodsFor: 'actions-dictionary' stamp: 'mu 6/2/2012 21:23'!
at: key ifAbsent: aBlock
	^self settingsDict at: key ifAbsent: aBlock! !

!N4Settings methodsFor: 'actions-dictionary' stamp: 'mu 6/2/2012 21:23'!
at: key ifAbsentPut: aBlock
	^self settingsDict at: key ifAbsentPut: aBlock! !

!N4Settings methodsFor: 'actions-dictionary' stamp: 'mu 6/2/2012 21:23'!
at: key put: value
	^self settingsDict at: key put: value! !

!N4Settings methodsFor: 'defaults' stamp: 'mu 5/27/2013 16:24'!
defaultRootUri
	^'http://localhost:7474/db/data/'! !

!N4Settings methodsFor: 'actions-dictionary' stamp: 'mu 6/2/2012 21:23'!
includesKey: key
	^self settingsDict includesKey: key! !

!N4Settings methodsFor: 'class initialization' stamp: 'mu 6/2/2012 21:23'!
initialize
	settingsDict := nil! !

!N4Settings methodsFor: 'accessing' stamp: 'mu 1/27/2013 16:26'!
keepConnection
	^self at: #keepConnection ifAbsentPut: [true]! !

!N4Settings methodsFor: 'accessing' stamp: 'mu 6/2/2012 21:27'!
keepConnection: aBoolean
	^self at: #keepConnection put: aBoolean == true! !

!N4Settings methodsFor: 'actions-dictionary' stamp: 'mu 6/2/2012 21:23'!
keys
	^self settingsDict keys! !

!N4Settings methodsFor: 'authentication' stamp: 'MasashiUmezawa 7/5/2015 22:34'!
password
	^self at: #password ifAbsentPut: ['neo4j']! !

!N4Settings methodsFor: 'authentication' stamp: 'MasashiUmezawa 7/5/2015 22:13'!
password: aString
	self at: #password put: aString! !

!N4Settings methodsFor: 'accessing' stamp: 'mu 5/27/2013 16:25'!
rootUri
	^ self at: #rootUri ifAbsentPut: [self defaultRootUri]! !

!N4Settings methodsFor: 'accessing' stamp: 'mu 5/27/2013 16:25'!
rootUri:  aString
	^self at: #keepConnection put: aString! !

!N4Settings methodsFor: 'accessing-private' stamp: 'mu 6/2/2012 21:23'!
settingsDict
	^ settingsDict ifNil: [settingsDict := IdentityDictionary new]! !

!N4Settings methodsFor: 'authentication' stamp: 'MasashiUmezawa 7/5/2015 22:25'!
useAuthentication
	^self at: #authentication ifAbsentPut: [true] "From Neo4j 2.0 - true by default"! !

!N4Settings methodsFor: 'authentication' stamp: 'MasashiUmezawa 7/5/2015 22:10'!
useAuthentication: aBoolean
	self at: #authentication put: aBoolean! !

!N4Settings methodsFor: 'authentication' stamp: 'MasashiUmezawa 7/5/2015 22:12'!
username
	^self at: #username ifAbsentPut: ['neo4j']! !

!N4Settings methodsFor: 'authentication' stamp: 'MasashiUmezawa 7/5/2015 22:13'!
username: aString
	self at: #username put: aString! !

Object subclass: #N4Url
	instanceVariableNames: 'baseUrlString components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!

!N4Url class methodsFor: 'instance creation' stamp: 'MasashiUmezawa 1/20/2013 23:14'!
baseUrlString: baseUrlString
	^self new baseUrlString: baseUrlString! !

!N4Url methodsFor: 'concatenating' stamp: 'MasashiUmezawa 1/21/2013 00:43'!
, pathConponent
	^(self class baseUrlString: self asString) // pathConponent! !

!N4Url methodsFor: 'concatenating' stamp: 'MasashiUmezawa 1/20/2013 23:50'!
/ stringPathConponent
	self components add: (self portableUtil stringFrom: stringPathConponent)! !

!N4Url methodsFor: 'concatenating' stamp: 'mu 1/27/2013 01:25'!
// pathConponent
	self components add: (self portableUtil urlEncodedStringFrom: pathConponent)! !

!N4Url methodsFor: 'converting' stamp: 'MasashiUmezawa 1/21/2013 00:47'!
asString
	| stream |
	self components isEmpty ifTrue: [^self baseUrlString].
	stream := WriteStream with: self baseUrlString.
	self components do: [:each | stream nextPutAll: each] separatedBy: [stream nextPut: $/].
	^stream contents! !

!N4Url methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/20/2013 23:35'!
baseUrlString
	^ baseUrlString ifNil: [baseUrlString := '']! !

!N4Url methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/20/2013 23:47'!
baseUrlString: anObject
	| string |
	anObject ifNil: [^baseUrlString := nil].
	string := anObject last = $/ ifTrue: [anObject] ifFalse: [anObject, '/'].
	baseUrlString := string! !

!N4Url methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/20/2013 23:35'!
components
	^ components ifNil: [components := OrderedCollection new]! !

!N4Url methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/20/2013 23:13'!
components: anObject
	components := anObject! !

!N4Url methodsFor: 'accessing' stamp: 'MasashiUmezawa 1/20/2013 23:23'!
portableUtil
	^ N4PortableUtil default! !

!N4Url methodsFor: 'printing' stamp: 'MasashiUmezawa 1/21/2013 00:26'!
printOn: aStream
	aStream nextPutAll: self asString! !

Dictionary subclass: #N4Dictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Core'!
N4PortableUtil initialize!
N4Settings initialize!
